//+------------------------------------------------------------------+
//|                                             BoxBreakout EAv1.mq4 |
//|                                 Copyright  2009.06.29, SwingMan |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009.06.29, SwingMan"
#property link      ""

/*--------------------------------------------------------------------
Idee: 4H Breakout thread
v1 2009.06.29 - 1 ATR in the middle of the first bar
              - Entry/Exit on Open      
//------------------------------------------------------------------*/

//---- extern parameters ---------------------------------------------
extern string p1 = "_____ATR_Factors_____";
extern double level1 = 1.0;
extern double level2 = 2.0;
extern double level3 = 3.0;
extern double Min_Lots = 0.10;
extern bool MoneyManagement = false;
extern double Risk = 2;
extern bool Show_WinLoss = true;
/*
extern bool SendAlert_Signals  = false;
//extern bool PlayAlert_Sound  = true;
extern bool SendEmail_Signals  = false;
//extern bool PrintAlert_Signals = false;
extern string p1 = "_____ATR_parameters_____";
extern int period_ATR = 34;
extern double Factor_InitialStopLoss = 2.0;
extern bool bShow_CommentActivTrades = false;
extern bool Show_TradingSignals    = false;
extern bool Show_TradingResults    = false;
extern bool Draw_SignalVertLines   = true;
*/
//--------------------------------------------------------------------

//---- constants
string EAComment = " [BoxBr]";
int MagicNumber = 90629;
string sTextAlert        = "BoxBreakout";
string subjectEmailAlert = "BoxBreakout";
string sLabelCode = "BoxBr_";

//---- variables
int TradingSignal;
int oldSignal, exitSignal;
datetime thisTime, oldTime;
double dPoint, dSignalOffset;
double EntryPrice, CurrentPrice;
int iDigits, roundDigits;
bool TradingOK;
//bool ThisIsNewBar;

//---- trading
double Spread, OrderSpread;
//double dATR;
int BreakEven_Points = 2;
double Factor_BreakEven = 0.5;
double Factor_TrailingSTop = 1.0;
//---- MagicGirlSAR variables
bool myLongSignal, myShortSignal;
int myExitSignal;
double BrokerMultiplier = 1;
double SumPips;
int SumTrades;
//---- BoxBreakout variables
double LongLevel[6], ShortLevel[6];

//---- includes
//#include <MagicStar_CommonsInclude.mqh>
#include <MagicStar_OrderInclude.mqh>
//#include <MagicStar_TradingInclude.mqh>

//####################################################################
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init(){   

   //==== DEFAULT settings ===============================
   nLots = Min_Lots;
   SumPips = 0;
   SumTrades = 0;
   //=================================================================

   TradingOK = (IsDemo() == true);
   if (TradingOK==false) {
      Alert("only demo accounts");
      return(0);
   }

   iDigits = MarketInfo(Symbol(), MODE_DIGITS);
   //dPoint  = MarketInfo(Symbol(), MODE_POINT);
   dPoint=Point*MathPow(10,Digits%2);
   if (Digits == 5 || Digits == 3) 
   {
      roundDigits =1; 
      Slippage_Entry = Slippage_Entry*10;
      Slippage_Exit  = Slippage_Exit*10;
      BrokerMultiplier = 10;
   }
   else 
   {
      roundDigits=0;   
   }  
  
   //dSignalOffset = Offset_EntryPoints*dPoint;      
   Comment("");   
   ObjectsDeleteAll();
   
   //-- initialisation
   mySystemSignal = 0;

   return(0);
}


//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
   return(0);
}


//####################################################################  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   if (TradingOK==false) return(0);
   
   /*thisTime = Time[0];
   if (thisTime != oldTime)
        oldTime = thisTime;   
   else return(0);*/
   
   //dATR = iATR(Symbol(),Period(),period_ATR, 1);
   
   Get_ActivOrder(MagicNumber);
   Get_IndicatorValues();
   Get_SignalValues();
   Check_ExitOrder();

   Get_ActivOrder(MagicNumber);  

//if (bShow_CommentActivTrades==true)
//Show_CommentActivTrades();   
//   if (Show_TradingSignals==true) 
//      Display_TradingSignals();      

   Get_TradingSignals();
   Check_SendNewOrder();
   Get_ActivOrder(MagicNumber);      
//   Set_InitialStopLoss();

   return(0);
}
//+------------------------------------------------------------------+



//####################################################################
//####################################################################
//+------------------------------------------------------------------+
//|      Get Indicator Values
//+------------------------------------------------------------------+
void Get_IndicatorValues()
{
string sSymbol = Symbol();
int iTF = Period();

   double dClose = iClose(sSymbol,iTF,0);

   return;
}

//####################################################################
//+------------------------------------------------------------------+
//    Get Signal Values
//+------------------------------------------------------------------+
void Get_SignalValues()
{
string sSymbol = Symbol();
int iTF = Period();
int iShift = 0;
      
   //-- Bar colour values -------------------------------
//   double dOpen  = iOpen(sSymbol, iTF,iShift);
//   double dClose = iClose(sSymbol,iTF,iShift);
   //int iValue_BarColour = 0;
   //if (dClose > dOpen) iValue_BarColour =  1; else
   //if (dClose < dOpen) iValue_BarColour = -1;
                 
   //-- SIGNALS
   //==========================================================
   int iOrderType = 0;
   
   //-- exit only vorticity
//   myExitSignal = myVorticity;
   
   //-- vorticity               
//   myLongSignal  = (myVorticity == 1); 
//   myShortSignal = (myVorticity == -1);
   
   TradingSignal = iOrderType;

   return;
}



//####################################################################
//+------------------------------------------------------------------+
//    Get Trading Signals
//+------------------------------------------------------------------+
void Get_TradingSignals()
{     
  /* //---- Trading Signal
   if (mySystemSignal == 100)
      return;
   TradingSignal =  mySystemSignal;*/
                                   
   return;       
}

//+------------------------------------------------------------------+
//    Check Send NewOrder
//+------------------------------------------------------------------+
void Check_SendNewOrder()
{  
string sSymbol = Symbol();
   if (nActivOrders > 0) return;
   nLots = Get_LotsNumber(MoneyManagement, Risk);
//if (Time[0] == D'2009.06.25 04:00')
//Comment("TradingSignal=",TradingSignal);
   //---- long
   if (TradingSignal == 1)
   {
      StopLossTrade = 0;
      SendOrder_BuyMarket(sSymbol, nLots, MagicNumber, EAComment); //-- BUY at market
   }
   else
   //---- short
   if (TradingSignal == -1)
   {
      StopLossTrade = 0;
      SendOrder_SellMarket(sSymbol, nLots, MagicNumber, EAComment); //-- SELL at Market
   }
}




//####################################################################
//####################################################################
//+------------------------------------------------------------------+
//    Check Exit Order
//+------------------------------------------------------------------+
void Check_ExitOrder()
{
string sSymbol = Symbol();
int iTF = Period();
int exitSignal;
double dHigh1, dLow1, dClose1;
double dBid, dAsk, dSpread, dSignalOffset;

   if (nActivOrders == 0) return;
   
   //================================================================
   exitSignal = 0;

   if (nActivOrders != 0) {
      //---- check long exit
      if (ActivOrderTyp == OP_BUY) {
         if (myExitSignal == -1) {
            exitSignal = 1;
         }
      }
      else
      //---- check short exit
      if (ActivOrderTyp == OP_SELL) {
         if (myExitSignal == 1) {
            exitSignal = -1; 
         }         
      }
         
      //-- send exit order 
      if (exitSignal != 0) {
         Send_ExitOrder(sSymbol, MagicNumber);
      }         
   }
   return;
}

//-------------------------------------------------------------------
//    Send Exit Order
//-------------------------------------------------------------------
void Send_ExitOrder(string sSymbol, int iMagicNumber)
{
   if (Show_WinLoss == true) {
      double Pair_TickValue = MarketInfo(sSymbol, MODE_TICKVALUE);
      double dValuePips = ProfitOrder / NumberLotsOrder / Pair_TickValue;
      SumPips = SumPips + dValuePips;
      SumTrades++;
      Comment("SumPips= ",DoubleToStr(SumPips,0), " / ",SumTrades," trades");
      
      if (ProfitOrder >= 0) {
         color dColor = DeepSkyBlue; 
         string sValue= DoubleToStr(dValuePips,0);
      }   
      else 
      {
         dColor = Magenta;
         sValue = "("+DoubleToStr(dValuePips,0)+")";
      }
      int iP = 20;
      datetime time1 = TimeCurrent();
      string sName = "win_" + TimeToStr(time1, TIME_DATE|TIME_MINUTES|TIME_SECONDS);
      double dHigh = iHigh(sSymbol,Period(),1);
      double dLow  = iLow(sSymbol,Period(),1);
      if (ActivOrderTyp == OP_BUY)  double yy = dHigh + 2*iP * Point; else
      if (ActivOrderTyp == OP_SELL) yy = dLow - iP * Point;
      ObjectCreate(sName, OBJ_TEXT, 0,time1, yy);
      ObjectSetText(sName, sValue, 10, "Courier New", dColor);
   }   

   //-- send exit order
   if (Close_ActivOrder(sSymbol, iMagicNumber) == true) {
      StopLossTrade = 0;   
      //-- avoid reentry
      mySystemSignal = 100;
   }
}

//####################################################################
//####################################################################
//+------------------------------------------------------------------+
//    Show Comment ActivTrades
//+------------------------------------------------------------------+
/*void Show_CommentActivTrades()
{
int is = 1;
string st = "";
   if (nActivOrders[is] > 0) 
   {
      if (ActivOrderTyp[is] ==OP_BUY) {
         st = st + "BUY,  long trade" + "\n";
         st = st + "StopLoss= " + DoubleToStr(StopLossTrade[is], Digits) + "\n";
         st = st  + "\n";
         st = st + "ProfitOrder= " + DoubleToStr(ProfitOrder[is], 2) + "\n";
      }
      else
      if (ActivOrderTyp[is] ==OP_SELL) 
      {
         st = st + "SELL,  short trade" + "\n";
         st = st + "StopLoss= " + DoubleToStr(StopLossTrade[is], Digits) + "\n";
         st = st  + "\n";
         st = st + "ProfitOrder= " + DoubleToStr(ProfitOrder[is], 2) + "\n";         
      }
      Comment(st);   
   }
   else
      Comment("no Trades");
   return;   
}*/


